# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{ config, lib, pkgs, modulesPath, ... }:

{
  imports = [
    (modulesPath + "/installer/scan/not-detected.nix")
  ];

  boot.initrd.availableKernelModules = [ "nvme" "xhci_pci" "usbhid" "usb_storage" "sd_mod" ];
  boot.initrd.kernelModules = [ ];
  boot.kernelModules = [ "kvm-amd" ];
  boot.kernelPackages = pkgs.linuxPackages_latest;
  boot.extraModulePackages = [ ];

  boot.initrd.luks.devices."luks".device = "/dev/disk/by-uuid/b56f6886-d301-455a-a4dd-2bbc96a99030";

  environment.systemPackages = with pkgs; [
    clinfo
  ];

  fileSystems."/" = {
    device = "/dev/mapper/luks";
    fsType = "btrfs";
    options = [ "subvol=@root" ];
  };

  fileSystems."/home" = {
    device = "/dev/mapper/luks";
    fsType = "btrfs";
    options = [ "subvol=@home" "compress=zstd" ];
  };

  fileSystems."/swap" = {
    device = "/dev/mapper/luks";
    fsType = "btrfs";
    options = [ "subvol=@swap" ];
  };

  fileSystems."/nix" = {
    device = "/dev/mapper/luks";
    fsType = "btrfs";
    options = [ "subvol=@nix" "noatime" ];
  };

  fileSystems."/boot" = {
    device = "/dev/disk/by-uuid/9B19-95A6";
    fsType = "vfat";
  };

  fileSystems."/mnt/crypt/Documents" = {
    device = "192.168.0.2:/Documents";
    fsType = "nfs";
  };

  fileSystems."/mnt/crypt/Pictures" = {
    device = "192.168.0.2:/Pictures";
    fsType = "nfs";
  };
  
  fileSystems."/mnt/crypt/Movies" = {
    device = "192.168.0.2:/Movies";
    fsType = "nfs";
  };
  
  fileSystems."/mnt/crypt/Series" = {
    device = "192.168.0.2:/Series";
    fsType = "nfs";
  };
  
  fileSystems."/mnt/crypt/Music" = {
    device = "192.168.0.2:/Music";
    fsType = "nfs";
  };

  swapDevices = [{ device = "/swap/swapfile"; }];

  hardware.graphics.enable = true;

  hardware.bluetooth.enable = true;
  hardware.bluetooth.powerOnBoot = true;
  services.blueman.enable = true;

  # Enables DHCP on each ethernet and wireless interface. In case of scripted networking
  # (the default) this is the recommended approach. When using systemd-networkd it's
  # still possible to use this option, but it's recommended to use it in conjunction
  # with explicit per-interface declarations with `networking.interfaces.<interface>.useDHCP`.
  networking.useDHCP = lib.mkDefault true;
  # networking.interfaces.enp6s0.useDHCP = lib.mkDefault true;

  nixpkgs.hostPlatform = lib.mkDefault "x86_64-linux";
  hardware.cpu.amd.updateMicrocode = lib.mkDefault config.hardware.enableRedistributableFirmware;
}
